JobShopSolve Class Reference

Model for solving. More...

## Public Types

enum | { BRANCH_AFC , BRANCH_ACTION , BRANCH_CHB }
| Branching to use. More...
enum | { PROP_ORDER , PROP_UNARY }
| Propagation to use. More...

## Public Member Functions

| JobShopSolve (const JobShopOptions &o)
| Actual model.
| JobShopSolve (JobShopSolve &s)
| Constructor for cloning s.
virtual Space * | copy (void)
| Copy during cloning.
Public Member Functions inherited from JobShopBase
| JobShopBase (const JobShopOptions &o)
| Actual model.
void | nooverload (void)
| Do not overload machines.
virtual IntVar | cost (void) const
| Return cost.
| JobShopBase (JobShopBase &s)
| Constructor for cloning s.
virtual void | print (std::ostream &os) const
| Print solution.
Public Member Functions inherited from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< IntMinimizeSpace > >
| ScriptBase (const Options &opt)
| Constructor.
| ScriptBase (ScriptBase &e)
| Constructor used for cloning.
virtual void | compare (const Space &home, std::ostream &os) const
| Compare with s.
Public Member Functions inherited from Gecode::Driver::IgnoreStepOption< BaseSpace >
| IgnoreStepOption (const Options &)
| Constructor.
| IgnoreStepOption (BaseSpace &e)
| Constructor used for cloning.

## Protected Member Functions

double | afc (BoolVar x, int i) const
| AFC-based cost.
double | action (int i) const
| Action-based cost.
double | chb (int i) const
| CHB-based cost.

## Static Protected Member Functions

static double | afcmerit (const Space &home, BoolVar x, int i)
| Trampoline function for AFC-based cost.
static double | actionmerit (const Space &home, BoolVar, int i)
| Trampoline function for Action-based cost.
static double | chbmerit (const Space &home, BoolVar, int i)
| Trampoline function for CHB-based cost.

## Protected Attributes

BoolVarArray | sorder
| Step order variables.
IntSharedArray | fst
| Record which step is first in order.
IntSharedArray | snd
| Record which step is second in order.
IntAFC | iafc
| AFC information.
IntAction | iaction
| Action information.
BoolAction | baction
IntCHB | ichb
| CHB information.
BoolCHB | bchb
Rnd | rnd
| Random number generator for probing and relaxation.
Protected Attributes inherited from JobShopBase
const JobShopOptions & | opt
| Options.
const Spec | spec
| Specification.
IntVarArray | start
| Start times for each step in a job.
IntVar | makespan
| Makespan.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< IntMinimizeSpace > >
static std::ostream & | select_ostream (const char *sn, std::ofstream &ofs)
| Choose output stream according to sn.
static void | run (const Options &opt, Script *s=NULL)

## Detailed Description

Model for solving.

Definition at line 409 of file job-shop.cpp.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Branching to use.

Enumerator
BRANCH_AFC | Branch using AFC.
BRANCH_ACTION | Branch using action.
BRANCH_CHB | Branch using CHB.

Definition at line 454 of file job-shop.cpp.

## anonymous enum

anonymous enum

Propagation to use.

Enumerator
PROP_ORDER | Only propagate order constraints.
PROP_UNARY | Also post unary constraints.

Definition at line 460 of file job-shop.cpp.

## Constructor & Destructor Documentation

## JobShopSolve() [1/2]

JobShopSolve::JobShopSolve | ( | const JobShopOptions & | o | ) |

inline

Actual model.

Definition at line 465 of file job-shop.cpp.

## JobShopSolve() [2/2]

JobShopSolve::JobShopSolve | ( | JobShopSolve & | s | ) |

inline

Constructor for cloning s.

Definition at line 565 of file job-shop.cpp.

## Member Function Documentation

## afc()

double JobShopSolve::afc | ( | BoolVar | x,
|  | int | i ) const

inline protected

AFC-based cost.

Definition at line 420 of file job-shop.cpp.

## afcmerit()

double JobShopSolve::afcmerit | ( | const Space & | home,
|  | BoolVar | x,
|  | int | i )

inline static protected

Trampoline function for AFC-based cost.

Definition at line 425 of file job-shop.cpp.

## action()

double JobShopSolve::action | ( | int | i | ) | const

inline protected

Action-based cost.

Definition at line 431 of file job-shop.cpp.

## actionmerit()

double JobShopSolve::actionmerit | ( | const Space & | home,
|  | BoolVar | ,
|  | int | i )

inline static protected

Trampoline function for Action-based cost.

Definition at line 436 of file job-shop.cpp.

## chb()

double JobShopSolve::chb | ( | int | i | ) | const

inline protected

CHB-based cost.

Definition at line 442 of file job-shop.cpp.

## chbmerit()

double JobShopSolve::chbmerit | ( | const Space & | home,
|  | BoolVar | ,
|  | int | i )

inline static protected

Trampoline function for CHB-based cost.

Definition at line 447 of file job-shop.cpp.

## copy()

virtual Space * JobShopSolve::copy | ( | void |  | ) |

inline virtual

Copy during cloning.

Definition at line 571 of file job-shop.cpp.

## Member Data Documentation

## sorder

BoolVarArray JobShopSolve::sorder

protected

Step order variables.

Definition at line 412 of file job-shop.cpp.

## fst

IntSharedArray JobShopSolve::fst

protected

Record which step is first in order.

Definition at line 414 of file job-shop.cpp.

## snd

IntSharedArray JobShopSolve::snd

protected

Record which step is second in order.

Definition at line 416 of file job-shop.cpp.

## iafc

IntAFC JobShopSolve::iafc

protected

AFC information.

Definition at line 418 of file job-shop.cpp.

## iaction

IntAction JobShopSolve::iaction

protected

Action information.

Definition at line 429 of file job-shop.cpp.

## baction

BoolAction JobShopSolve::baction

protected

Definition at line 429 of file job-shop.cpp.

## ichb

IntCHB JobShopSolve::ichb

protected

CHB information.

Definition at line 440 of file job-shop.cpp.

## bchb

BoolCHB JobShopSolve::bchb

protected

Definition at line 440 of file job-shop.cpp.

## rnd

Rnd JobShopSolve::rnd

protected

Random number generator for probing and relaxation.

Definition at line 451 of file job-shop.cpp.

The documentation for this class was generated from the following file:

- examples/job-shop.cpp